<?php
ini_set('display_errors', 1);

require_once '../../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning . "faculty_api/faculty_function/common_faculty_function.php";
require_once $base_path_to_learning . "principal_api/principal_function/principal_function.php";
require_once $base_path_to_learning_resources . 'lib/common_modules/item/functions.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['second_party']) or !checkIfIssetAndNotEmpty($postdata['second_party']) or
    !isset($postdata['quantity']) or !checkIfIssetAndNotEmpty($postdata['quantity']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, ['teacher'], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);

$function_type = trim($postdata['function_type']);
$item_id = $postdata['item_id'];
$quantity = $postdata['quantity'];
$second_party = $postdata['second_party'];
$transaction_type = "transfer";
$remarks = isset($postdata['remarks']) ? $postdata['remarks'] : null;

$date = date('Y-m-d');
$time = time();

$Faculty_Codes = $conn_rjllearning_specific->prepare("SELECT id FROM faculty_info WHERE userid = ? AND institution_id = ? AND branch_id = ?");
$Faculty_Codes->execute(array($userid, $institution_id, $branch_id));

// Fetch a single row instead of all
$result_faculty = $Faculty_Codes->fetch(PDO::FETCH_ASSOC);

// Check if the faculty exists
if ($result_faculty === false) {
    errorreturn("Faculty Not Found.");
}

if ($postdata['function_type'] == "transfer_item") {

    try {

        $faculty_id = $result_faculty['id'];
        $faculty_data = getClassSectionSubjectsAndInChargeRoles($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $userid);

        $class_section_subjects  = $faculty_data['class_section_subjects'];
        $class_incharge_roles = $faculty_data['class_incharge_roles'];
        $staff_access_modules = $faculty_data['staff_access_modules'];

        $check_faculty_status = checkFacultyModuleGranted($function_type, $class_section_subjects, $class_incharge_roles, $staff_access_modules, null, null, null, $conn_rjllearning);
        if($check_faculty_status == false){
            errorreturn("Access denied: You do not have the required permissions.");
        }
        
        if ($branch_id == $second_party) {
            errorreturn("Cannot transfer items to the same branch. Please select a different destination.");
        }
        
        $sql = "INSERT INTO inventory_transactions (institution_id, branch_id, item_id, quantity, second_party, transaction_type, date,created_by,created_at,remarks,status) 
                VALUES (?, ?, ?, ?, ?, ?, ?, ?,?,?,?)";
        
        $stmt = $conn_rjllearning_specific->prepare($sql);
        $params = [$institution_id, $branch_id, $item_id, $quantity, $second_party, $transaction_type, $date,$username,$date,$remarks,0];
        
        $stmt->execute($params);

        successreturn(["status" => "success", "message" => "Inventory item transferred successfully."]);
    } catch (PDOException $e) {
        errorreturn(["status" => "error", "message" => "Database error: " . $e->getMessage()]);
    }
}
